﻿
using System;
using System.Net;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Management;
using System.IO;
using System.Windows;
using System.Collections;


namespace VZInterfaceTestHandbook
{
  public partial class FormAuthentication : Form
  {
    IComIf comIf;
    Handbook handbook = new Handbook();
    Boolean isConnected = false;

    public FormAuthentication(IComIf com)
    {
      comIf = com;
      InitializeComponent();
    }

    /**
     * Open connection
     * @return success = false
     */
    private Boolean connOpen()
    {
      if (comIf.Open())
      {
        MessageBox.Show("Couldn´t open interface!", "Error",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
        return true;
      }
      isConnected = true;
      return false;
    }

    /**
     * Close connection
     */
    private void connClose()
    {
      if(isConnected)
        comIf.Close();
      isConnected = false;
    }

    //@@@START_BUTTONLOGIN@@@
    private void buttonLogin_Click(object sender, EventArgs e)
    {
      // Enables to convert string into byte array
      System.Text.Encoding enc = System.Text.Encoding.ASCII;

      /*Collect username,password and IP*/
      Byte[] user = enc.GetBytes(tbUsername.Text);
      Byte[] passw = enc.GetBytes(tbPassword.Text);

      Byte[] ip;
      System.Net.IPAddress Ip;
      System.Net.IPAddress.TryParse(handbook.sendIP(), out Ip);
      ip = Ip.GetAddressBytes();

      /*Padding*/
      Byte[] username = new Byte[16];
      // Because the username must have a length of 16 Bytes,
      // the missing Bytes have to be filled up with "0"
      if (user.Length < tbUsername.MaxLength)
      {

        for (int i = 0; i < username.Length; i++)
        {
          // Fill up the username with the converted Bytes of the 
          // string from the textbox "tbUsername"
          if (i < user.Length)
            username[i] = user[i];
          // Fill up the rest of Bytes with "0"
          else
            username[i] = 0x00;
        }
      }

      Byte[] password = new Byte[10];
      // Because the password must have a length of 10 Bytes,
      // the missing Bytes have to be filled up with "0"
      if (passw.Length < tbPassword.MaxLength)
      {
        for (int i = 0; i < password.Length; i++)
        {
          // Fill up the password with the converted Bytes of the 
          // string from the textbox "tbPassword"
          if (i < passw.Length)
            password[i] = passw[i];
          // Fill up the rest of Bytes with "0"
          else
            password[i] = 0x00;
        }
      }
      /*Send commands*/
      Authentication auth = new Authentication(comIf);
      if (connOpen())
        return;
      if (auth.Login(username, password, ip))  //only in case of an error close the connection, otherwise leave it open to be able to send out more commands.
        connClose();
    }
    //@@@STOP_BUTTONLOGIN@@@

    private void buttonReturn_Click(object sender, EventArgs e)
    {
      connClose();
      Close();
    }

    private void buttonLogout_Click(object sender, EventArgs e)
    {
      Authentication auth = new Authentication(comIf);
      auth.Logout();
      connClose();
    }

    private void FormAuthentication_FormClosing(object sender, FormClosingEventArgs e)
    {
      connClose();
    }
  }
}
