﻿
using System;
using System.Windows;
using System.Windows.Forms;
using System.Collections;
using System.Collections.Generic;

namespace VZInterfaceTestHandbook
{
  /**
   * Power commands
   */
  public partial class PowerSettings
  {
    private IComIf comIf;

    /**
     * @param com: uses Interface IComIf
     */
    public PowerSettings(IComIf com)
    {
      comIf = com;
    }


    /**
     * Shows the current state of the command
     */

    public void ShowState(Byte GetByte)
    {
      switch (GetByte)
      {
        case 0x00:
          MessageBox.Show("Powerstate: Off");
          break;
        case 0x01:
          MessageBox.Show("Powerstate: On");
          break;
      }
    }

    /**
     * Power ON
     */

    //@@@START_POWERON@@@
    public void PowerON()
    {
      Wolfprot2 wp2 = new Wolfprot2(comIf);
      Boolean iReturn;
      /*Declaration*/
      Byte[] bufSnd = new Byte[4];
      Byte[] bufRecv = new Byte[3];

      /*Assignment*/
      bufSnd[0] = 0x01;
      bufSnd[1] = 0x30;
      bufSnd[2] = 0x01;
      bufSnd[3] = 0x01;

      /*Send command*/
      iReturn = wp2.execCmd(bufSnd, ref bufRecv);
      if (iReturn == true)
      {
        MessageBox.Show("No communication!", "Error",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
      }
      else
      {
        if ((bufRecv[0] & 0x80) == 0x80)
          wp2.ErrorSummary(bufRecv[2]);
        else
          MessageBox.Show("Command successful");
      }
    }
    //@@@STOP_POWERON@@@

    /**
     * Power Off
     */

    public void PowerOff()
    {
      Wolfprot2 wp2 = new Wolfprot2(comIf);
      Byte[] bufSnd = new Byte[4];
      Byte[] bufRecv = new Byte[3];
      Boolean iReturn;

      /*Assignment*/
      bufSnd[0] = 0x01;
      bufSnd[1] = 0x30;
      bufSnd[2] = 0x01;
      bufSnd[3] = 0x00;

      /*Send command*/
      iReturn = wp2.execCmd(bufSnd, ref bufRecv);
      if (iReturn == true)
      {
        MessageBox.Show("No communication!", "Error",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
      }
      else
      {
        if ((bufRecv[0] & 0x80) == 0x80)
          wp2.ErrorSummary(bufRecv[2]);
        else
          MessageBox.Show("Command successful");
      }
    }

    /**
     * Get Power State
     */

    //@@@START_GETPOWERSTATE@@@
    public void GetPowerState()
    {
      Wolfprot2 wp2 = new Wolfprot2(comIf);
      Boolean iReturn;
      /*Declaration*/
      Byte[] bufSnd = new Byte[3];
      Byte[] bufRecv = new Byte[4];

      /*Assignment*/
      bufSnd[0] = 0x00;
      bufSnd[1] = 0x30;
      bufSnd[2] = 0x00;

      /*Send command*/
      iReturn = wp2.execCmd(bufSnd, ref bufRecv);
      if (iReturn == true)
      {
        MessageBox.Show("No communication!", "Error",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
      }
      else if ((bufRecv[0] & 0x80) == 0x80)
        wp2.ErrorSummary(bufRecv[2]);
      else
      {
        ShowState(bufRecv[3]);
      }
    }
    //@@@STOP_GETPOWERSTATE@@@
  }
}
